'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _server = require('react-dom/server');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var HAS_RESOLVED = 'ReactResolver.HAS_RESOLVED';
var IS_CLIENT = 'ReactResolver.IS_CLIENT';

var Resolver = function (_React$Component) {
  _inherits(Resolver, _React$Component);

  function Resolver(props, context) {
    _classCallCheck(this, Resolver);

    var _this = _possibleConstructorReturn(this, (Resolver.__proto__ || Object.getPrototypeOf(Resolver)).call(this, props, context));

    _this.unMounted = true;

    _this[HAS_RESOLVED] = false;
    _this[IS_CLIENT] = false;

    _this.state = _this.computeState(_this.props, {
      pending: {},
      resolved: {}
    });

    if (_this.isPending(_this.state)) {
      _this.resolve(_this.state);
      _this[HAS_RESOLVED] = false;
    } else {
      _this[HAS_RESOLVED] = true;
    }
    return _this;
  }

  _createClass(Resolver, [{
    key: 'cached',
    value: function cached(resolve) {
      var _props = this.props,
          props = _props.props,
          cache = _props.cache;


      if (cache || isServer) {
        if (props.hasOwnProperty(resolve)) {
          return props[resolve];
        } else if (this.context.resolver) {
          return this.context.resolver.cached(resolve);
        }
      }

      return null;
    }
  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.unMounted = false;
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this[IS_CLIENT] = true;
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.unMounted = true;
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var _computeState = this.computeState(nextProps, this.state),
          pending = _computeState.pending,
          resolved = _computeState.resolved;

      this.setAtomicState({
        pending: pending,
        resolved: resolved
      });
    }
  }, {
    key: 'computeState',
    value: function computeState(thisProps, state) {
      var _this2 = this;

      var resolve = thisProps.resolve;

      var nextState = state;

      Object.keys(resolve).forEach(function (name) {
        var cached = _this2.cached(name);

        if (!state.resolved.hasOwnProperty(name) && !state.pending.hasOwnProperty(name) && !cached) {
          nextState.pending[name] = resolve[name];
        } else if (cached) {
          nextState.resolved[name] = true;
        }
      });

      return nextState;
    }
  }, {
    key: 'getChildContext',
    value: function getChildContext() {
      return { resolver: this };
    }
  }, {
    key: 'isPending',
    value: function isPending() {
      var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.state;

      return Object.keys(state.pending).length > 0;
    }
  }, {
    key: 'isParentPending',
    value: function isParentPending() {
      var resolver = this.context.resolver;


      if (resolver) {
        return resolver.isPending() || resolver.isParentPending();
      }

      return false;
    }
  }, {
    key: 'onResolve',
    value: function onResolve(state) {
      if (this.props.onResolve) {
        return this.props.onResolve(state);
      } else if (this.context.resolver) {
        return this.context.resolver.onResolve(state);
      } else {
        return state;
      }
    }
  }, {
    key: 'render',
    value: function render() {
      if (!this[HAS_RESOLVED]) {
        return false;
      }

      if (this.isPending(this.state)) {
        this.resolve(this.state);
      }

      return this.props.children(_extends({}, this.props.props));
    }
  }, {
    key: 'resolve',
    value: function resolve(state) {
      var _this3 = this;

      var props = this.props.props;


      var pending = Object.keys(state.pending).map(function (name) {
        var func = state.pending[name];

        return { name: name, func: func };
      });

      var promises = pending.map(function (_ref) {
        var func = _ref.func;
        return func(props);
      });

      var resolving = Promise.all(promises).then(function (values) {
        return values.reduce(function (resolved, value, i) {
          resolved[pending[i].name] = true;

          return resolved;
        }, {});
      });

      resolving = this.onResolve(resolving);

      resolving.then(function (resolved) {
        _this3[HAS_RESOLVED] = true;

        if (!_this3[IS_CLIENT]) {
          return false;
        }

        var nextState = {
          pending: {},
          resolved: _extends({}, state.resolved, resolved)
        };

        _this3.setAtomicState(nextState);
      });
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      if (this.isParentPending()) {
        return false;
      }

      if (this.isPending(nextState)) {
        return false;
      }

      return this[HAS_RESOLVED];
    }
  }, {
    key: 'setAtomicState',
    value: function setAtomicState(nextState) {
      if (this.unMounted) {
        return;
      }

      this.setState(nextState);
    }
  }]);

  return Resolver;
}(_react2.default.Component);

Resolver.childContextTypes = {
  resolver: _propTypes2.default.object
};
Resolver.contextTypes = {
  resolver: _propTypes2.default.object
};
Resolver.defaultProps = {
  props: {},
  resolve: {}
};
Resolver.displayName = 'Resolver';
Resolver.propTypes = {
  children: _propTypes2.default.func.isRequired,
  props: _propTypes2.default.object,
  resolve: _propTypes2.default.object
};

Resolver.renderClient = function (render, node) {
  _reactDom2.default.render(_react2.default.createElement(
    Resolver,
    null,
    render
  ), node);
};

Resolver.renderServer = function (_render) {
  var initialData = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  var queue = [];

  (0, _server.renderToStaticMarkup)(_react2.default.createElement(
    Resolver,
    { onResolve: function onResolve(promise) {
        queue.push(promise);

        return Promise.resolve(true);
      } },
    _render
  ));

  return Promise.all(queue).then(function (results) {
    var formatResults = {};
    results.forEach(function (item) {
      return Object.keys(item).forEach(function (key) {
        formatResults[key] = item[key];
      });
    });

    var data = _extends({}, initialData, formatResults);

    if (Object.keys(initialData).length < Object.keys(data).length) {
      return Resolver.renderServer(_render, data);
    }

    var Resolved = function (_React$Component2) {
      _inherits(Resolved, _React$Component2);

      function Resolved() {
        _classCallCheck(this, Resolved);

        return _possibleConstructorReturn(this, (Resolved.__proto__ || Object.getPrototypeOf(Resolved)).apply(this, arguments));
      }

      _createClass(Resolved, [{
        key: 'render',
        value: function render() {
          return _react2.default.createElement(
            Resolver,
            null,
            _render
          );
        }
      }]);

      return Resolved;
    }(_react2.default.Component);

    Resolved.displayName = 'Resolved';


    return Resolved;
  });
};

exports.default = Resolver;